# Intrinio API
#
# Welcome to the Intrinio API! Through our Financial Data Marketplace, we offer a wide selection of financial data feed APIs sourced by our own proprietary processes as well as from many data vendors. For a complete API request / response reference please view the [Intrinio API documentation](https://intrinio.com/documentation/api_v2). If you need additional help in using the API, please visit the [Intrinio website](https://intrinio.com) and click on the chat icon in the lower right corner.
#
# OpenAPI spec version: 2.23.0
# 
# Generated by: https://github.com/swagger-api/swagger-codegen.git


#' ETFStats Class
#'
#' @field date 
#' @field net_asset_value 
#' @field beta_vs_spy 
#' @field trailing_one_month_return_split_and_dividend 
#' @field trailing_one_month_return_split_only 
#' @field trailing_one_year_return_split_and_dividend 
#' @field trailing_one_year_return_split_only 
#' @field trailing_one_year_volatility_annualized 
#' @field trailing_three_year_annualized_return_split_and_dividend 
#' @field trailing_three_year_annualized_return_split_only 
#' @field trailing_three_year_volatility_annualized 
#' @field trailing_five_year_annualized_return_split_and_dividend 
#' @field trailing_five_year_annualized_return_split_only 
#' @field trailing_five_year_volatility_annualized 
#' @field trailing_ten_year_annualized_return_split_and_dividend 
#' @field trailing_ten_year_annualized_return_split_only 
#' @field inception_annualized_return_split_and_dividend 
#' @field inception_annualized_return_split_only 
#' @field calendar_year_5_return_split_and_dividend 
#' @field calendar_year_5_return_split_only 
#' @field calendar_year_4_return_split_and_dividend 
#' @field calendar_year_4_return_split_only 
#' @field calendar_year_3_return_split_and_dividend 
#' @field calendar_year_3_return_split_only 
#' @field calendar_year_2_return_split_and_dividend 
#' @field calendar_year_2_return_split_only 
#' @field calendar_year_1_return_split_and_dividend 
#' @field calendar_year_1_return_split_only 
#' @field calendar_year_to_date_return_split_and_dividend 
#' @field calendar_year_to_date_return_split_only 
#' @field etf 
#'
#' @importFrom R6 R6Class
#' @importFrom jsonlite fromJSON toJSON
#' @export
ETFStats <- R6::R6Class(
  'ETFStats',
  public = list(
    `date` = NA,
    `net_asset_value` = NA,
    `beta_vs_spy` = NA,
    `trailing_one_month_return_split_and_dividend` = NA,
    `trailing_one_month_return_split_only` = NA,
    `trailing_one_year_return_split_and_dividend` = NA,
    `trailing_one_year_return_split_only` = NA,
    `trailing_one_year_volatility_annualized` = NA,
    `trailing_three_year_annualized_return_split_and_dividend` = NA,
    `trailing_three_year_annualized_return_split_only` = NA,
    `trailing_three_year_volatility_annualized` = NA,
    `trailing_five_year_annualized_return_split_and_dividend` = NA,
    `trailing_five_year_annualized_return_split_only` = NA,
    `trailing_five_year_volatility_annualized` = NA,
    `trailing_ten_year_annualized_return_split_and_dividend` = NA,
    `trailing_ten_year_annualized_return_split_only` = NA,
    `inception_annualized_return_split_and_dividend` = NA,
    `inception_annualized_return_split_only` = NA,
    `calendar_year_5_return_split_and_dividend` = NA,
    `calendar_year_5_return_split_only` = NA,
    `calendar_year_4_return_split_and_dividend` = NA,
    `calendar_year_4_return_split_only` = NA,
    `calendar_year_3_return_split_and_dividend` = NA,
    `calendar_year_3_return_split_only` = NA,
    `calendar_year_2_return_split_and_dividend` = NA,
    `calendar_year_2_return_split_only` = NA,
    `calendar_year_1_return_split_and_dividend` = NA,
    `calendar_year_1_return_split_only` = NA,
    `calendar_year_to_date_return_split_and_dividend` = NA,
    `calendar_year_to_date_return_split_only` = NA,
    `etf` = NA,
    initialize = function(`date`, `net_asset_value`, `beta_vs_spy`, `trailing_one_month_return_split_and_dividend`, `trailing_one_month_return_split_only`, `trailing_one_year_return_split_and_dividend`, `trailing_one_year_return_split_only`, `trailing_one_year_volatility_annualized`, `trailing_three_year_annualized_return_split_and_dividend`, `trailing_three_year_annualized_return_split_only`, `trailing_three_year_volatility_annualized`, `trailing_five_year_annualized_return_split_and_dividend`, `trailing_five_year_annualized_return_split_only`, `trailing_five_year_volatility_annualized`, `trailing_ten_year_annualized_return_split_and_dividend`, `trailing_ten_year_annualized_return_split_only`, `inception_annualized_return_split_and_dividend`, `inception_annualized_return_split_only`, `calendar_year_5_return_split_and_dividend`, `calendar_year_5_return_split_only`, `calendar_year_4_return_split_and_dividend`, `calendar_year_4_return_split_only`, `calendar_year_3_return_split_and_dividend`, `calendar_year_3_return_split_only`, `calendar_year_2_return_split_and_dividend`, `calendar_year_2_return_split_only`, `calendar_year_1_return_split_and_dividend`, `calendar_year_1_return_split_only`, `calendar_year_to_date_return_split_and_dividend`, `calendar_year_to_date_return_split_only`, `etf`){
      if (!missing(`date`)) {
        self$`date` <- `date`
      }
      if (!missing(`net_asset_value`)) {
        self$`net_asset_value` <- `net_asset_value`
      }
      if (!missing(`beta_vs_spy`)) {
        self$`beta_vs_spy` <- `beta_vs_spy`
      }
      if (!missing(`trailing_one_month_return_split_and_dividend`)) {
        self$`trailing_one_month_return_split_and_dividend` <- `trailing_one_month_return_split_and_dividend`
      }
      if (!missing(`trailing_one_month_return_split_only`)) {
        self$`trailing_one_month_return_split_only` <- `trailing_one_month_return_split_only`
      }
      if (!missing(`trailing_one_year_return_split_and_dividend`)) {
        self$`trailing_one_year_return_split_and_dividend` <- `trailing_one_year_return_split_and_dividend`
      }
      if (!missing(`trailing_one_year_return_split_only`)) {
        self$`trailing_one_year_return_split_only` <- `trailing_one_year_return_split_only`
      }
      if (!missing(`trailing_one_year_volatility_annualized`)) {
        self$`trailing_one_year_volatility_annualized` <- `trailing_one_year_volatility_annualized`
      }
      if (!missing(`trailing_three_year_annualized_return_split_and_dividend`)) {
        self$`trailing_three_year_annualized_return_split_and_dividend` <- `trailing_three_year_annualized_return_split_and_dividend`
      }
      if (!missing(`trailing_three_year_annualized_return_split_only`)) {
        self$`trailing_three_year_annualized_return_split_only` <- `trailing_three_year_annualized_return_split_only`
      }
      if (!missing(`trailing_three_year_volatility_annualized`)) {
        self$`trailing_three_year_volatility_annualized` <- `trailing_three_year_volatility_annualized`
      }
      if (!missing(`trailing_five_year_annualized_return_split_and_dividend`)) {
        self$`trailing_five_year_annualized_return_split_and_dividend` <- `trailing_five_year_annualized_return_split_and_dividend`
      }
      if (!missing(`trailing_five_year_annualized_return_split_only`)) {
        self$`trailing_five_year_annualized_return_split_only` <- `trailing_five_year_annualized_return_split_only`
      }
      if (!missing(`trailing_five_year_volatility_annualized`)) {
        self$`trailing_five_year_volatility_annualized` <- `trailing_five_year_volatility_annualized`
      }
      if (!missing(`trailing_ten_year_annualized_return_split_and_dividend`)) {
        self$`trailing_ten_year_annualized_return_split_and_dividend` <- `trailing_ten_year_annualized_return_split_and_dividend`
      }
      if (!missing(`trailing_ten_year_annualized_return_split_only`)) {
        self$`trailing_ten_year_annualized_return_split_only` <- `trailing_ten_year_annualized_return_split_only`
      }
      if (!missing(`inception_annualized_return_split_and_dividend`)) {
        self$`inception_annualized_return_split_and_dividend` <- `inception_annualized_return_split_and_dividend`
      }
      if (!missing(`inception_annualized_return_split_only`)) {
        self$`inception_annualized_return_split_only` <- `inception_annualized_return_split_only`
      }
      if (!missing(`calendar_year_5_return_split_and_dividend`)) {
        self$`calendar_year_5_return_split_and_dividend` <- `calendar_year_5_return_split_and_dividend`
      }
      if (!missing(`calendar_year_5_return_split_only`)) {
        self$`calendar_year_5_return_split_only` <- `calendar_year_5_return_split_only`
      }
      if (!missing(`calendar_year_4_return_split_and_dividend`)) {
        self$`calendar_year_4_return_split_and_dividend` <- `calendar_year_4_return_split_and_dividend`
      }
      if (!missing(`calendar_year_4_return_split_only`)) {
        self$`calendar_year_4_return_split_only` <- `calendar_year_4_return_split_only`
      }
      if (!missing(`calendar_year_3_return_split_and_dividend`)) {
        self$`calendar_year_3_return_split_and_dividend` <- `calendar_year_3_return_split_and_dividend`
      }
      if (!missing(`calendar_year_3_return_split_only`)) {
        self$`calendar_year_3_return_split_only` <- `calendar_year_3_return_split_only`
      }
      if (!missing(`calendar_year_2_return_split_and_dividend`)) {
        self$`calendar_year_2_return_split_and_dividend` <- `calendar_year_2_return_split_and_dividend`
      }
      if (!missing(`calendar_year_2_return_split_only`)) {
        self$`calendar_year_2_return_split_only` <- `calendar_year_2_return_split_only`
      }
      if (!missing(`calendar_year_1_return_split_and_dividend`)) {
        self$`calendar_year_1_return_split_and_dividend` <- `calendar_year_1_return_split_and_dividend`
      }
      if (!missing(`calendar_year_1_return_split_only`)) {
        self$`calendar_year_1_return_split_only` <- `calendar_year_1_return_split_only`
      }
      if (!missing(`calendar_year_to_date_return_split_and_dividend`)) {
        self$`calendar_year_to_date_return_split_and_dividend` <- `calendar_year_to_date_return_split_and_dividend`
      }
      if (!missing(`calendar_year_to_date_return_split_only`)) {
        self$`calendar_year_to_date_return_split_only` <- `calendar_year_to_date_return_split_only`
      }
      if (!missing(`etf`)) {
        self$`etf` <- `etf`
      }
    },
    toJSON = function() {
      ETFStatsObject <- list()
      if (!is.null(self$`date`)) {
        # If the object is an empty list or a list of R6 Objects
        if (is.list(self$`date`) && ((length(self$`date`) == 0) || ((length(self$`date`) != 0 && R6::is.R6(self$`date`[[1]]))))) {
          ETFStatsObject[['date']] <- lapply(self$`date`, function(x) x$toJSON())
        } else {
          ETFStatsObject[['date']] <- jsonlite::toJSON(self$`date`, auto_unbox = TRUE)
        }
      }
      if (!is.null(self$`net_asset_value`)) {
        # If the object is an empty list or a list of R6 Objects
        if (is.list(self$`net_asset_value`) && ((length(self$`net_asset_value`) == 0) || ((length(self$`net_asset_value`) != 0 && R6::is.R6(self$`net_asset_value`[[1]]))))) {
          ETFStatsObject[['net_asset_value']] <- lapply(self$`net_asset_value`, function(x) x$toJSON())
        } else {
          ETFStatsObject[['net_asset_value']] <- jsonlite::toJSON(self$`net_asset_value`, auto_unbox = TRUE)
        }
      }
      if (!is.null(self$`beta_vs_spy`)) {
        # If the object is an empty list or a list of R6 Objects
        if (is.list(self$`beta_vs_spy`) && ((length(self$`beta_vs_spy`) == 0) || ((length(self$`beta_vs_spy`) != 0 && R6::is.R6(self$`beta_vs_spy`[[1]]))))) {
          ETFStatsObject[['beta_vs_spy']] <- lapply(self$`beta_vs_spy`, function(x) x$toJSON())
        } else {
          ETFStatsObject[['beta_vs_spy']] <- jsonlite::toJSON(self$`beta_vs_spy`, auto_unbox = TRUE)
        }
      }
      if (!is.null(self$`trailing_one_month_return_split_and_dividend`)) {
        # If the object is an empty list or a list of R6 Objects
        if (is.list(self$`trailing_one_month_return_split_and_dividend`) && ((length(self$`trailing_one_month_return_split_and_dividend`) == 0) || ((length(self$`trailing_one_month_return_split_and_dividend`) != 0 && R6::is.R6(self$`trailing_one_month_return_split_and_dividend`[[1]]))))) {
          ETFStatsObject[['trailing_one_month_return_split_and_dividend']] <- lapply(self$`trailing_one_month_return_split_and_dividend`, function(x) x$toJSON())
        } else {
          ETFStatsObject[['trailing_one_month_return_split_and_dividend']] <- jsonlite::toJSON(self$`trailing_one_month_return_split_and_dividend`, auto_unbox = TRUE)
        }
      }
      if (!is.null(self$`trailing_one_month_return_split_only`)) {
        # If the object is an empty list or a list of R6 Objects
        if (is.list(self$`trailing_one_month_return_split_only`) && ((length(self$`trailing_one_month_return_split_only`) == 0) || ((length(self$`trailing_one_month_return_split_only`) != 0 && R6::is.R6(self$`trailing_one_month_return_split_only`[[1]]))))) {
          ETFStatsObject[['trailing_one_month_return_split_only']] <- lapply(self$`trailing_one_month_return_split_only`, function(x) x$toJSON())
        } else {
          ETFStatsObject[['trailing_one_month_return_split_only']] <- jsonlite::toJSON(self$`trailing_one_month_return_split_only`, auto_unbox = TRUE)
        }
      }
      if (!is.null(self$`trailing_one_year_return_split_and_dividend`)) {
        # If the object is an empty list or a list of R6 Objects
        if (is.list(self$`trailing_one_year_return_split_and_dividend`) && ((length(self$`trailing_one_year_return_split_and_dividend`) == 0) || ((length(self$`trailing_one_year_return_split_and_dividend`) != 0 && R6::is.R6(self$`trailing_one_year_return_split_and_dividend`[[1]]))))) {
          ETFStatsObject[['trailing_one_year_return_split_and_dividend']] <- lapply(self$`trailing_one_year_return_split_and_dividend`, function(x) x$toJSON())
        } else {
          ETFStatsObject[['trailing_one_year_return_split_and_dividend']] <- jsonlite::toJSON(self$`trailing_one_year_return_split_and_dividend`, auto_unbox = TRUE)
        }
      }
      if (!is.null(self$`trailing_one_year_return_split_only`)) {
        # If the object is an empty list or a list of R6 Objects
        if (is.list(self$`trailing_one_year_return_split_only`) && ((length(self$`trailing_one_year_return_split_only`) == 0) || ((length(self$`trailing_one_year_return_split_only`) != 0 && R6::is.R6(self$`trailing_one_year_return_split_only`[[1]]))))) {
          ETFStatsObject[['trailing_one_year_return_split_only']] <- lapply(self$`trailing_one_year_return_split_only`, function(x) x$toJSON())
        } else {
          ETFStatsObject[['trailing_one_year_return_split_only']] <- jsonlite::toJSON(self$`trailing_one_year_return_split_only`, auto_unbox = TRUE)
        }
      }
      if (!is.null(self$`trailing_one_year_volatility_annualized`)) {
        # If the object is an empty list or a list of R6 Objects
        if (is.list(self$`trailing_one_year_volatility_annualized`) && ((length(self$`trailing_one_year_volatility_annualized`) == 0) || ((length(self$`trailing_one_year_volatility_annualized`) != 0 && R6::is.R6(self$`trailing_one_year_volatility_annualized`[[1]]))))) {
          ETFStatsObject[['trailing_one_year_volatility_annualized']] <- lapply(self$`trailing_one_year_volatility_annualized`, function(x) x$toJSON())
        } else {
          ETFStatsObject[['trailing_one_year_volatility_annualized']] <- jsonlite::toJSON(self$`trailing_one_year_volatility_annualized`, auto_unbox = TRUE)
        }
      }
      if (!is.null(self$`trailing_three_year_annualized_return_split_and_dividend`)) {
        # If the object is an empty list or a list of R6 Objects
        if (is.list(self$`trailing_three_year_annualized_return_split_and_dividend`) && ((length(self$`trailing_three_year_annualized_return_split_and_dividend`) == 0) || ((length(self$`trailing_three_year_annualized_return_split_and_dividend`) != 0 && R6::is.R6(self$`trailing_three_year_annualized_return_split_and_dividend`[[1]]))))) {
          ETFStatsObject[['trailing_three_year_annualized_return_split_and_dividend']] <- lapply(self$`trailing_three_year_annualized_return_split_and_dividend`, function(x) x$toJSON())
        } else {
          ETFStatsObject[['trailing_three_year_annualized_return_split_and_dividend']] <- jsonlite::toJSON(self$`trailing_three_year_annualized_return_split_and_dividend`, auto_unbox = TRUE)
        }
      }
      if (!is.null(self$`trailing_three_year_annualized_return_split_only`)) {
        # If the object is an empty list or a list of R6 Objects
        if (is.list(self$`trailing_three_year_annualized_return_split_only`) && ((length(self$`trailing_three_year_annualized_return_split_only`) == 0) || ((length(self$`trailing_three_year_annualized_return_split_only`) != 0 && R6::is.R6(self$`trailing_three_year_annualized_return_split_only`[[1]]))))) {
          ETFStatsObject[['trailing_three_year_annualized_return_split_only']] <- lapply(self$`trailing_three_year_annualized_return_split_only`, function(x) x$toJSON())
        } else {
          ETFStatsObject[['trailing_three_year_annualized_return_split_only']] <- jsonlite::toJSON(self$`trailing_three_year_annualized_return_split_only`, auto_unbox = TRUE)
        }
      }
      if (!is.null(self$`trailing_three_year_volatility_annualized`)) {
        # If the object is an empty list or a list of R6 Objects
        if (is.list(self$`trailing_three_year_volatility_annualized`) && ((length(self$`trailing_three_year_volatility_annualized`) == 0) || ((length(self$`trailing_three_year_volatility_annualized`) != 0 && R6::is.R6(self$`trailing_three_year_volatility_annualized`[[1]]))))) {
          ETFStatsObject[['trailing_three_year_volatility_annualized']] <- lapply(self$`trailing_three_year_volatility_annualized`, function(x) x$toJSON())
        } else {
          ETFStatsObject[['trailing_three_year_volatility_annualized']] <- jsonlite::toJSON(self$`trailing_three_year_volatility_annualized`, auto_unbox = TRUE)
        }
      }
      if (!is.null(self$`trailing_five_year_annualized_return_split_and_dividend`)) {
        # If the object is an empty list or a list of R6 Objects
        if (is.list(self$`trailing_five_year_annualized_return_split_and_dividend`) && ((length(self$`trailing_five_year_annualized_return_split_and_dividend`) == 0) || ((length(self$`trailing_five_year_annualized_return_split_and_dividend`) != 0 && R6::is.R6(self$`trailing_five_year_annualized_return_split_and_dividend`[[1]]))))) {
          ETFStatsObject[['trailing_five_year_annualized_return_split_and_dividend']] <- lapply(self$`trailing_five_year_annualized_return_split_and_dividend`, function(x) x$toJSON())
        } else {
          ETFStatsObject[['trailing_five_year_annualized_return_split_and_dividend']] <- jsonlite::toJSON(self$`trailing_five_year_annualized_return_split_and_dividend`, auto_unbox = TRUE)
        }
      }
      if (!is.null(self$`trailing_five_year_annualized_return_split_only`)) {
        # If the object is an empty list or a list of R6 Objects
        if (is.list(self$`trailing_five_year_annualized_return_split_only`) && ((length(self$`trailing_five_year_annualized_return_split_only`) == 0) || ((length(self$`trailing_five_year_annualized_return_split_only`) != 0 && R6::is.R6(self$`trailing_five_year_annualized_return_split_only`[[1]]))))) {
          ETFStatsObject[['trailing_five_year_annualized_return_split_only']] <- lapply(self$`trailing_five_year_annualized_return_split_only`, function(x) x$toJSON())
        } else {
          ETFStatsObject[['trailing_five_year_annualized_return_split_only']] <- jsonlite::toJSON(self$`trailing_five_year_annualized_return_split_only`, auto_unbox = TRUE)
        }
      }
      if (!is.null(self$`trailing_five_year_volatility_annualized`)) {
        # If the object is an empty list or a list of R6 Objects
        if (is.list(self$`trailing_five_year_volatility_annualized`) && ((length(self$`trailing_five_year_volatility_annualized`) == 0) || ((length(self$`trailing_five_year_volatility_annualized`) != 0 && R6::is.R6(self$`trailing_five_year_volatility_annualized`[[1]]))))) {
          ETFStatsObject[['trailing_five_year_volatility_annualized']] <- lapply(self$`trailing_five_year_volatility_annualized`, function(x) x$toJSON())
        } else {
          ETFStatsObject[['trailing_five_year_volatility_annualized']] <- jsonlite::toJSON(self$`trailing_five_year_volatility_annualized`, auto_unbox = TRUE)
        }
      }
      if (!is.null(self$`trailing_ten_year_annualized_return_split_and_dividend`)) {
        # If the object is an empty list or a list of R6 Objects
        if (is.list(self$`trailing_ten_year_annualized_return_split_and_dividend`) && ((length(self$`trailing_ten_year_annualized_return_split_and_dividend`) == 0) || ((length(self$`trailing_ten_year_annualized_return_split_and_dividend`) != 0 && R6::is.R6(self$`trailing_ten_year_annualized_return_split_and_dividend`[[1]]))))) {
          ETFStatsObject[['trailing_ten_year_annualized_return_split_and_dividend']] <- lapply(self$`trailing_ten_year_annualized_return_split_and_dividend`, function(x) x$toJSON())
        } else {
          ETFStatsObject[['trailing_ten_year_annualized_return_split_and_dividend']] <- jsonlite::toJSON(self$`trailing_ten_year_annualized_return_split_and_dividend`, auto_unbox = TRUE)
        }
      }
      if (!is.null(self$`trailing_ten_year_annualized_return_split_only`)) {
        # If the object is an empty list or a list of R6 Objects
        if (is.list(self$`trailing_ten_year_annualized_return_split_only`) && ((length(self$`trailing_ten_year_annualized_return_split_only`) == 0) || ((length(self$`trailing_ten_year_annualized_return_split_only`) != 0 && R6::is.R6(self$`trailing_ten_year_annualized_return_split_only`[[1]]))))) {
          ETFStatsObject[['trailing_ten_year_annualized_return_split_only']] <- lapply(self$`trailing_ten_year_annualized_return_split_only`, function(x) x$toJSON())
        } else {
          ETFStatsObject[['trailing_ten_year_annualized_return_split_only']] <- jsonlite::toJSON(self$`trailing_ten_year_annualized_return_split_only`, auto_unbox = TRUE)
        }
      }
      if (!is.null(self$`inception_annualized_return_split_and_dividend`)) {
        # If the object is an empty list or a list of R6 Objects
        if (is.list(self$`inception_annualized_return_split_and_dividend`) && ((length(self$`inception_annualized_return_split_and_dividend`) == 0) || ((length(self$`inception_annualized_return_split_and_dividend`) != 0 && R6::is.R6(self$`inception_annualized_return_split_and_dividend`[[1]]))))) {
          ETFStatsObject[['inception_annualized_return_split_and_dividend']] <- lapply(self$`inception_annualized_return_split_and_dividend`, function(x) x$toJSON())
        } else {
          ETFStatsObject[['inception_annualized_return_split_and_dividend']] <- jsonlite::toJSON(self$`inception_annualized_return_split_and_dividend`, auto_unbox = TRUE)
        }
      }
      if (!is.null(self$`inception_annualized_return_split_only`)) {
        # If the object is an empty list or a list of R6 Objects
        if (is.list(self$`inception_annualized_return_split_only`) && ((length(self$`inception_annualized_return_split_only`) == 0) || ((length(self$`inception_annualized_return_split_only`) != 0 && R6::is.R6(self$`inception_annualized_return_split_only`[[1]]))))) {
          ETFStatsObject[['inception_annualized_return_split_only']] <- lapply(self$`inception_annualized_return_split_only`, function(x) x$toJSON())
        } else {
          ETFStatsObject[['inception_annualized_return_split_only']] <- jsonlite::toJSON(self$`inception_annualized_return_split_only`, auto_unbox = TRUE)
        }
      }
      if (!is.null(self$`calendar_year_5_return_split_and_dividend`)) {
        # If the object is an empty list or a list of R6 Objects
        if (is.list(self$`calendar_year_5_return_split_and_dividend`) && ((length(self$`calendar_year_5_return_split_and_dividend`) == 0) || ((length(self$`calendar_year_5_return_split_and_dividend`) != 0 && R6::is.R6(self$`calendar_year_5_return_split_and_dividend`[[1]]))))) {
          ETFStatsObject[['calendar_year_5_return_split_and_dividend']] <- lapply(self$`calendar_year_5_return_split_and_dividend`, function(x) x$toJSON())
        } else {
          ETFStatsObject[['calendar_year_5_return_split_and_dividend']] <- jsonlite::toJSON(self$`calendar_year_5_return_split_and_dividend`, auto_unbox = TRUE)
        }
      }
      if (!is.null(self$`calendar_year_5_return_split_only`)) {
        # If the object is an empty list or a list of R6 Objects
        if (is.list(self$`calendar_year_5_return_split_only`) && ((length(self$`calendar_year_5_return_split_only`) == 0) || ((length(self$`calendar_year_5_return_split_only`) != 0 && R6::is.R6(self$`calendar_year_5_return_split_only`[[1]]))))) {
          ETFStatsObject[['calendar_year_5_return_split_only']] <- lapply(self$`calendar_year_5_return_split_only`, function(x) x$toJSON())
        } else {
          ETFStatsObject[['calendar_year_5_return_split_only']] <- jsonlite::toJSON(self$`calendar_year_5_return_split_only`, auto_unbox = TRUE)
        }
      }
      if (!is.null(self$`calendar_year_4_return_split_and_dividend`)) {
        # If the object is an empty list or a list of R6 Objects
        if (is.list(self$`calendar_year_4_return_split_and_dividend`) && ((length(self$`calendar_year_4_return_split_and_dividend`) == 0) || ((length(self$`calendar_year_4_return_split_and_dividend`) != 0 && R6::is.R6(self$`calendar_year_4_return_split_and_dividend`[[1]]))))) {
          ETFStatsObject[['calendar_year_4_return_split_and_dividend']] <- lapply(self$`calendar_year_4_return_split_and_dividend`, function(x) x$toJSON())
        } else {
          ETFStatsObject[['calendar_year_4_return_split_and_dividend']] <- jsonlite::toJSON(self$`calendar_year_4_return_split_and_dividend`, auto_unbox = TRUE)
        }
      }
      if (!is.null(self$`calendar_year_4_return_split_only`)) {
        # If the object is an empty list or a list of R6 Objects
        if (is.list(self$`calendar_year_4_return_split_only`) && ((length(self$`calendar_year_4_return_split_only`) == 0) || ((length(self$`calendar_year_4_return_split_only`) != 0 && R6::is.R6(self$`calendar_year_4_return_split_only`[[1]]))))) {
          ETFStatsObject[['calendar_year_4_return_split_only']] <- lapply(self$`calendar_year_4_return_split_only`, function(x) x$toJSON())
        } else {
          ETFStatsObject[['calendar_year_4_return_split_only']] <- jsonlite::toJSON(self$`calendar_year_4_return_split_only`, auto_unbox = TRUE)
        }
      }
      if (!is.null(self$`calendar_year_3_return_split_and_dividend`)) {
        # If the object is an empty list or a list of R6 Objects
        if (is.list(self$`calendar_year_3_return_split_and_dividend`) && ((length(self$`calendar_year_3_return_split_and_dividend`) == 0) || ((length(self$`calendar_year_3_return_split_and_dividend`) != 0 && R6::is.R6(self$`calendar_year_3_return_split_and_dividend`[[1]]))))) {
          ETFStatsObject[['calendar_year_3_return_split_and_dividend']] <- lapply(self$`calendar_year_3_return_split_and_dividend`, function(x) x$toJSON())
        } else {
          ETFStatsObject[['calendar_year_3_return_split_and_dividend']] <- jsonlite::toJSON(self$`calendar_year_3_return_split_and_dividend`, auto_unbox = TRUE)
        }
      }
      if (!is.null(self$`calendar_year_3_return_split_only`)) {
        # If the object is an empty list or a list of R6 Objects
        if (is.list(self$`calendar_year_3_return_split_only`) && ((length(self$`calendar_year_3_return_split_only`) == 0) || ((length(self$`calendar_year_3_return_split_only`) != 0 && R6::is.R6(self$`calendar_year_3_return_split_only`[[1]]))))) {
          ETFStatsObject[['calendar_year_3_return_split_only']] <- lapply(self$`calendar_year_3_return_split_only`, function(x) x$toJSON())
        } else {
          ETFStatsObject[['calendar_year_3_return_split_only']] <- jsonlite::toJSON(self$`calendar_year_3_return_split_only`, auto_unbox = TRUE)
        }
      }
      if (!is.null(self$`calendar_year_2_return_split_and_dividend`)) {
        # If the object is an empty list or a list of R6 Objects
        if (is.list(self$`calendar_year_2_return_split_and_dividend`) && ((length(self$`calendar_year_2_return_split_and_dividend`) == 0) || ((length(self$`calendar_year_2_return_split_and_dividend`) != 0 && R6::is.R6(self$`calendar_year_2_return_split_and_dividend`[[1]]))))) {
          ETFStatsObject[['calendar_year_2_return_split_and_dividend']] <- lapply(self$`calendar_year_2_return_split_and_dividend`, function(x) x$toJSON())
        } else {
          ETFStatsObject[['calendar_year_2_return_split_and_dividend']] <- jsonlite::toJSON(self$`calendar_year_2_return_split_and_dividend`, auto_unbox = TRUE)
        }
      }
      if (!is.null(self$`calendar_year_2_return_split_only`)) {
        # If the object is an empty list or a list of R6 Objects
        if (is.list(self$`calendar_year_2_return_split_only`) && ((length(self$`calendar_year_2_return_split_only`) == 0) || ((length(self$`calendar_year_2_return_split_only`) != 0 && R6::is.R6(self$`calendar_year_2_return_split_only`[[1]]))))) {
          ETFStatsObject[['calendar_year_2_return_split_only']] <- lapply(self$`calendar_year_2_return_split_only`, function(x) x$toJSON())
        } else {
          ETFStatsObject[['calendar_year_2_return_split_only']] <- jsonlite::toJSON(self$`calendar_year_2_return_split_only`, auto_unbox = TRUE)
        }
      }
      if (!is.null(self$`calendar_year_1_return_split_and_dividend`)) {
        # If the object is an empty list or a list of R6 Objects
        if (is.list(self$`calendar_year_1_return_split_and_dividend`) && ((length(self$`calendar_year_1_return_split_and_dividend`) == 0) || ((length(self$`calendar_year_1_return_split_and_dividend`) != 0 && R6::is.R6(self$`calendar_year_1_return_split_and_dividend`[[1]]))))) {
          ETFStatsObject[['calendar_year_1_return_split_and_dividend']] <- lapply(self$`calendar_year_1_return_split_and_dividend`, function(x) x$toJSON())
        } else {
          ETFStatsObject[['calendar_year_1_return_split_and_dividend']] <- jsonlite::toJSON(self$`calendar_year_1_return_split_and_dividend`, auto_unbox = TRUE)
        }
      }
      if (!is.null(self$`calendar_year_1_return_split_only`)) {
        # If the object is an empty list or a list of R6 Objects
        if (is.list(self$`calendar_year_1_return_split_only`) && ((length(self$`calendar_year_1_return_split_only`) == 0) || ((length(self$`calendar_year_1_return_split_only`) != 0 && R6::is.R6(self$`calendar_year_1_return_split_only`[[1]]))))) {
          ETFStatsObject[['calendar_year_1_return_split_only']] <- lapply(self$`calendar_year_1_return_split_only`, function(x) x$toJSON())
        } else {
          ETFStatsObject[['calendar_year_1_return_split_only']] <- jsonlite::toJSON(self$`calendar_year_1_return_split_only`, auto_unbox = TRUE)
        }
      }
      if (!is.null(self$`calendar_year_to_date_return_split_and_dividend`)) {
        # If the object is an empty list or a list of R6 Objects
        if (is.list(self$`calendar_year_to_date_return_split_and_dividend`) && ((length(self$`calendar_year_to_date_return_split_and_dividend`) == 0) || ((length(self$`calendar_year_to_date_return_split_and_dividend`) != 0 && R6::is.R6(self$`calendar_year_to_date_return_split_and_dividend`[[1]]))))) {
          ETFStatsObject[['calendar_year_to_date_return_split_and_dividend']] <- lapply(self$`calendar_year_to_date_return_split_and_dividend`, function(x) x$toJSON())
        } else {
          ETFStatsObject[['calendar_year_to_date_return_split_and_dividend']] <- jsonlite::toJSON(self$`calendar_year_to_date_return_split_and_dividend`, auto_unbox = TRUE)
        }
      }
      if (!is.null(self$`calendar_year_to_date_return_split_only`)) {
        # If the object is an empty list or a list of R6 Objects
        if (is.list(self$`calendar_year_to_date_return_split_only`) && ((length(self$`calendar_year_to_date_return_split_only`) == 0) || ((length(self$`calendar_year_to_date_return_split_only`) != 0 && R6::is.R6(self$`calendar_year_to_date_return_split_only`[[1]]))))) {
          ETFStatsObject[['calendar_year_to_date_return_split_only']] <- lapply(self$`calendar_year_to_date_return_split_only`, function(x) x$toJSON())
        } else {
          ETFStatsObject[['calendar_year_to_date_return_split_only']] <- jsonlite::toJSON(self$`calendar_year_to_date_return_split_only`, auto_unbox = TRUE)
        }
      }
      if (!is.null(self$`etf`)) {
        # If the object is an empty list or a list of R6 Objects
        if (is.list(self$`etf`) && ((length(self$`etf`) == 0) || ((length(self$`etf`) != 0 && R6::is.R6(self$`etf`[[1]]))))) {
          ETFStatsObject[['etf']] <- lapply(self$`etf`, function(x) x$toJSON())
        } else {
          ETFStatsObject[['etf']] <- jsonlite::toJSON(self$`etf`, auto_unbox = TRUE)
        }
      }

      ETFStatsObject
    },
    fromJSON = function(ETFStatsJson) {
      ETFStatsObject <- jsonlite::fromJSON(ETFStatsJson)
      if (!is.null(ETFStatsObject$`date`)) {
        self$`date` <- ETFStatsObject$`date`
      }
      if (!is.null(ETFStatsObject$`net_asset_value`)) {
        self$`net_asset_value` <- ETFStatsObject$`net_asset_value`
      }
      if (!is.null(ETFStatsObject$`beta_vs_spy`)) {
        self$`beta_vs_spy` <- ETFStatsObject$`beta_vs_spy`
      }
      if (!is.null(ETFStatsObject$`trailing_one_month_return_split_and_dividend`)) {
        self$`trailing_one_month_return_split_and_dividend` <- ETFStatsObject$`trailing_one_month_return_split_and_dividend`
      }
      if (!is.null(ETFStatsObject$`trailing_one_month_return_split_only`)) {
        self$`trailing_one_month_return_split_only` <- ETFStatsObject$`trailing_one_month_return_split_only`
      }
      if (!is.null(ETFStatsObject$`trailing_one_year_return_split_and_dividend`)) {
        self$`trailing_one_year_return_split_and_dividend` <- ETFStatsObject$`trailing_one_year_return_split_and_dividend`
      }
      if (!is.null(ETFStatsObject$`trailing_one_year_return_split_only`)) {
        self$`trailing_one_year_return_split_only` <- ETFStatsObject$`trailing_one_year_return_split_only`
      }
      if (!is.null(ETFStatsObject$`trailing_one_year_volatility_annualized`)) {
        self$`trailing_one_year_volatility_annualized` <- ETFStatsObject$`trailing_one_year_volatility_annualized`
      }
      if (!is.null(ETFStatsObject$`trailing_three_year_annualized_return_split_and_dividend`)) {
        self$`trailing_three_year_annualized_return_split_and_dividend` <- ETFStatsObject$`trailing_three_year_annualized_return_split_and_dividend`
      }
      if (!is.null(ETFStatsObject$`trailing_three_year_annualized_return_split_only`)) {
        self$`trailing_three_year_annualized_return_split_only` <- ETFStatsObject$`trailing_three_year_annualized_return_split_only`
      }
      if (!is.null(ETFStatsObject$`trailing_three_year_volatility_annualized`)) {
        self$`trailing_three_year_volatility_annualized` <- ETFStatsObject$`trailing_three_year_volatility_annualized`
      }
      if (!is.null(ETFStatsObject$`trailing_five_year_annualized_return_split_and_dividend`)) {
        self$`trailing_five_year_annualized_return_split_and_dividend` <- ETFStatsObject$`trailing_five_year_annualized_return_split_and_dividend`
      }
      if (!is.null(ETFStatsObject$`trailing_five_year_annualized_return_split_only`)) {
        self$`trailing_five_year_annualized_return_split_only` <- ETFStatsObject$`trailing_five_year_annualized_return_split_only`
      }
      if (!is.null(ETFStatsObject$`trailing_five_year_volatility_annualized`)) {
        self$`trailing_five_year_volatility_annualized` <- ETFStatsObject$`trailing_five_year_volatility_annualized`
      }
      if (!is.null(ETFStatsObject$`trailing_ten_year_annualized_return_split_and_dividend`)) {
        self$`trailing_ten_year_annualized_return_split_and_dividend` <- ETFStatsObject$`trailing_ten_year_annualized_return_split_and_dividend`
      }
      if (!is.null(ETFStatsObject$`trailing_ten_year_annualized_return_split_only`)) {
        self$`trailing_ten_year_annualized_return_split_only` <- ETFStatsObject$`trailing_ten_year_annualized_return_split_only`
      }
      if (!is.null(ETFStatsObject$`inception_annualized_return_split_and_dividend`)) {
        self$`inception_annualized_return_split_and_dividend` <- ETFStatsObject$`inception_annualized_return_split_and_dividend`
      }
      if (!is.null(ETFStatsObject$`inception_annualized_return_split_only`)) {
        self$`inception_annualized_return_split_only` <- ETFStatsObject$`inception_annualized_return_split_only`
      }
      if (!is.null(ETFStatsObject$`calendar_year_5_return_split_and_dividend`)) {
        self$`calendar_year_5_return_split_and_dividend` <- ETFStatsObject$`calendar_year_5_return_split_and_dividend`
      }
      if (!is.null(ETFStatsObject$`calendar_year_5_return_split_only`)) {
        self$`calendar_year_5_return_split_only` <- ETFStatsObject$`calendar_year_5_return_split_only`
      }
      if (!is.null(ETFStatsObject$`calendar_year_4_return_split_and_dividend`)) {
        self$`calendar_year_4_return_split_and_dividend` <- ETFStatsObject$`calendar_year_4_return_split_and_dividend`
      }
      if (!is.null(ETFStatsObject$`calendar_year_4_return_split_only`)) {
        self$`calendar_year_4_return_split_only` <- ETFStatsObject$`calendar_year_4_return_split_only`
      }
      if (!is.null(ETFStatsObject$`calendar_year_3_return_split_and_dividend`)) {
        self$`calendar_year_3_return_split_and_dividend` <- ETFStatsObject$`calendar_year_3_return_split_and_dividend`
      }
      if (!is.null(ETFStatsObject$`calendar_year_3_return_split_only`)) {
        self$`calendar_year_3_return_split_only` <- ETFStatsObject$`calendar_year_3_return_split_only`
      }
      if (!is.null(ETFStatsObject$`calendar_year_2_return_split_and_dividend`)) {
        self$`calendar_year_2_return_split_and_dividend` <- ETFStatsObject$`calendar_year_2_return_split_and_dividend`
      }
      if (!is.null(ETFStatsObject$`calendar_year_2_return_split_only`)) {
        self$`calendar_year_2_return_split_only` <- ETFStatsObject$`calendar_year_2_return_split_only`
      }
      if (!is.null(ETFStatsObject$`calendar_year_1_return_split_and_dividend`)) {
        self$`calendar_year_1_return_split_and_dividend` <- ETFStatsObject$`calendar_year_1_return_split_and_dividend`
      }
      if (!is.null(ETFStatsObject$`calendar_year_1_return_split_only`)) {
        self$`calendar_year_1_return_split_only` <- ETFStatsObject$`calendar_year_1_return_split_only`
      }
      if (!is.null(ETFStatsObject$`calendar_year_to_date_return_split_and_dividend`)) {
        self$`calendar_year_to_date_return_split_and_dividend` <- ETFStatsObject$`calendar_year_to_date_return_split_and_dividend`
      }
      if (!is.null(ETFStatsObject$`calendar_year_to_date_return_split_only`)) {
        self$`calendar_year_to_date_return_split_only` <- ETFStatsObject$`calendar_year_to_date_return_split_only`
      }
      if (!is.null(ETFStatsObject$`etf`)) {
        self$`etf` <- ETFStatsObject$`etf`
      }
    },
    toJSONString = function() {
      jsonlite::toJSON(self$toJSON(), auto_unbox = TRUE, pretty = TRUE)
    },
    fromJSONString = function(ETFStatsJson) {
      ETFStatsObject <- jsonlite::fromJSON(ETFStatsJson, simplifyDataFrame = FALSE)
      self$setFromList(ETFStatsObject)
    },
    setFromList = function(listObject) {



      if (!is.null(listObject$`date`)) {
        self$`date` <- self$`date` <- as.Date(listObject$`date`, "%Y-%m-%d")
      }
      else {
        self$`date` <- NA 
      }





      if (!is.null(listObject$`net_asset_value`)) {
        self$`net_asset_value` <- listObject$`net_asset_value`
      }
      else {
        self$`net_asset_value` <- NA 
      }

      if (!is.null(listObject$`beta_vs_spy`)) {
        self$`beta_vs_spy` <- listObject$`beta_vs_spy`
      }
      else {
        self$`beta_vs_spy` <- NA 
      }

      if (!is.null(listObject$`trailing_one_month_return_split_and_dividend`)) {
        self$`trailing_one_month_return_split_and_dividend` <- listObject$`trailing_one_month_return_split_and_dividend`
      }
      else {
        self$`trailing_one_month_return_split_and_dividend` <- NA 
      }

      if (!is.null(listObject$`trailing_one_month_return_split_only`)) {
        self$`trailing_one_month_return_split_only` <- listObject$`trailing_one_month_return_split_only`
      }
      else {
        self$`trailing_one_month_return_split_only` <- NA 
      }

      if (!is.null(listObject$`trailing_one_year_return_split_and_dividend`)) {
        self$`trailing_one_year_return_split_and_dividend` <- listObject$`trailing_one_year_return_split_and_dividend`
      }
      else {
        self$`trailing_one_year_return_split_and_dividend` <- NA 
      }

      if (!is.null(listObject$`trailing_one_year_return_split_only`)) {
        self$`trailing_one_year_return_split_only` <- listObject$`trailing_one_year_return_split_only`
      }
      else {
        self$`trailing_one_year_return_split_only` <- NA 
      }

      if (!is.null(listObject$`trailing_one_year_volatility_annualized`)) {
        self$`trailing_one_year_volatility_annualized` <- listObject$`trailing_one_year_volatility_annualized`
      }
      else {
        self$`trailing_one_year_volatility_annualized` <- NA 
      }

      if (!is.null(listObject$`trailing_three_year_annualized_return_split_and_dividend`)) {
        self$`trailing_three_year_annualized_return_split_and_dividend` <- listObject$`trailing_three_year_annualized_return_split_and_dividend`
      }
      else {
        self$`trailing_three_year_annualized_return_split_and_dividend` <- NA 
      }

      if (!is.null(listObject$`trailing_three_year_annualized_return_split_only`)) {
        self$`trailing_three_year_annualized_return_split_only` <- listObject$`trailing_three_year_annualized_return_split_only`
      }
      else {
        self$`trailing_three_year_annualized_return_split_only` <- NA 
      }

      if (!is.null(listObject$`trailing_three_year_volatility_annualized`)) {
        self$`trailing_three_year_volatility_annualized` <- listObject$`trailing_three_year_volatility_annualized`
      }
      else {
        self$`trailing_three_year_volatility_annualized` <- NA 
      }

      if (!is.null(listObject$`trailing_five_year_annualized_return_split_and_dividend`)) {
        self$`trailing_five_year_annualized_return_split_and_dividend` <- listObject$`trailing_five_year_annualized_return_split_and_dividend`
      }
      else {
        self$`trailing_five_year_annualized_return_split_and_dividend` <- NA 
      }

      if (!is.null(listObject$`trailing_five_year_annualized_return_split_only`)) {
        self$`trailing_five_year_annualized_return_split_only` <- listObject$`trailing_five_year_annualized_return_split_only`
      }
      else {
        self$`trailing_five_year_annualized_return_split_only` <- NA 
      }

      if (!is.null(listObject$`trailing_five_year_volatility_annualized`)) {
        self$`trailing_five_year_volatility_annualized` <- listObject$`trailing_five_year_volatility_annualized`
      }
      else {
        self$`trailing_five_year_volatility_annualized` <- NA 
      }

      if (!is.null(listObject$`trailing_ten_year_annualized_return_split_and_dividend`)) {
        self$`trailing_ten_year_annualized_return_split_and_dividend` <- listObject$`trailing_ten_year_annualized_return_split_and_dividend`
      }
      else {
        self$`trailing_ten_year_annualized_return_split_and_dividend` <- NA 
      }

      if (!is.null(listObject$`trailing_ten_year_annualized_return_split_only`)) {
        self$`trailing_ten_year_annualized_return_split_only` <- listObject$`trailing_ten_year_annualized_return_split_only`
      }
      else {
        self$`trailing_ten_year_annualized_return_split_only` <- NA 
      }

      if (!is.null(listObject$`inception_annualized_return_split_and_dividend`)) {
        self$`inception_annualized_return_split_and_dividend` <- listObject$`inception_annualized_return_split_and_dividend`
      }
      else {
        self$`inception_annualized_return_split_and_dividend` <- NA 
      }

      if (!is.null(listObject$`inception_annualized_return_split_only`)) {
        self$`inception_annualized_return_split_only` <- listObject$`inception_annualized_return_split_only`
      }
      else {
        self$`inception_annualized_return_split_only` <- NA 
      }

      if (!is.null(listObject$`calendar_year_5_return_split_and_dividend`)) {
        self$`calendar_year_5_return_split_and_dividend` <- listObject$`calendar_year_5_return_split_and_dividend`
      }
      else {
        self$`calendar_year_5_return_split_and_dividend` <- NA 
      }

      if (!is.null(listObject$`calendar_year_5_return_split_only`)) {
        self$`calendar_year_5_return_split_only` <- listObject$`calendar_year_5_return_split_only`
      }
      else {
        self$`calendar_year_5_return_split_only` <- NA 
      }

      if (!is.null(listObject$`calendar_year_4_return_split_and_dividend`)) {
        self$`calendar_year_4_return_split_and_dividend` <- listObject$`calendar_year_4_return_split_and_dividend`
      }
      else {
        self$`calendar_year_4_return_split_and_dividend` <- NA 
      }

      if (!is.null(listObject$`calendar_year_4_return_split_only`)) {
        self$`calendar_year_4_return_split_only` <- listObject$`calendar_year_4_return_split_only`
      }
      else {
        self$`calendar_year_4_return_split_only` <- NA 
      }

      if (!is.null(listObject$`calendar_year_3_return_split_and_dividend`)) {
        self$`calendar_year_3_return_split_and_dividend` <- listObject$`calendar_year_3_return_split_and_dividend`
      }
      else {
        self$`calendar_year_3_return_split_and_dividend` <- NA 
      }

      if (!is.null(listObject$`calendar_year_3_return_split_only`)) {
        self$`calendar_year_3_return_split_only` <- listObject$`calendar_year_3_return_split_only`
      }
      else {
        self$`calendar_year_3_return_split_only` <- NA 
      }

      if (!is.null(listObject$`calendar_year_2_return_split_and_dividend`)) {
        self$`calendar_year_2_return_split_and_dividend` <- listObject$`calendar_year_2_return_split_and_dividend`
      }
      else {
        self$`calendar_year_2_return_split_and_dividend` <- NA 
      }

      if (!is.null(listObject$`calendar_year_2_return_split_only`)) {
        self$`calendar_year_2_return_split_only` <- listObject$`calendar_year_2_return_split_only`
      }
      else {
        self$`calendar_year_2_return_split_only` <- NA 
      }

      if (!is.null(listObject$`calendar_year_1_return_split_and_dividend`)) {
        self$`calendar_year_1_return_split_and_dividend` <- listObject$`calendar_year_1_return_split_and_dividend`
      }
      else {
        self$`calendar_year_1_return_split_and_dividend` <- NA 
      }

      if (!is.null(listObject$`calendar_year_1_return_split_only`)) {
        self$`calendar_year_1_return_split_only` <- listObject$`calendar_year_1_return_split_only`
      }
      else {
        self$`calendar_year_1_return_split_only` <- NA 
      }

      if (!is.null(listObject$`calendar_year_to_date_return_split_and_dividend`)) {
        self$`calendar_year_to_date_return_split_and_dividend` <- listObject$`calendar_year_to_date_return_split_and_dividend`
      }
      else {
        self$`calendar_year_to_date_return_split_and_dividend` <- NA 
      }

      if (!is.null(listObject$`calendar_year_to_date_return_split_only`)) {
        self$`calendar_year_to_date_return_split_only` <- listObject$`calendar_year_to_date_return_split_only`
      }
      else {
        self$`calendar_year_to_date_return_split_only` <- NA 
      }








      self$`etf` <- ETFSummary$new()
      self$`etf`$setFromList(listObject$`etf`)

    },
    getAsList = function() {
      listObject = list()

      listObject[["date"]] <- self$`date`



        
      listObject[["net_asset_value"]] <- self$`net_asset_value`
      listObject[["beta_vs_spy"]] <- self$`beta_vs_spy`
      listObject[["trailing_one_month_return_split_and_dividend"]] <- self$`trailing_one_month_return_split_and_dividend`
      listObject[["trailing_one_month_return_split_only"]] <- self$`trailing_one_month_return_split_only`
      listObject[["trailing_one_year_return_split_and_dividend"]] <- self$`trailing_one_year_return_split_and_dividend`
      listObject[["trailing_one_year_return_split_only"]] <- self$`trailing_one_year_return_split_only`
      listObject[["trailing_one_year_volatility_annualized"]] <- self$`trailing_one_year_volatility_annualized`
      listObject[["trailing_three_year_annualized_return_split_and_dividend"]] <- self$`trailing_three_year_annualized_return_split_and_dividend`
      listObject[["trailing_three_year_annualized_return_split_only"]] <- self$`trailing_three_year_annualized_return_split_only`
      listObject[["trailing_three_year_volatility_annualized"]] <- self$`trailing_three_year_volatility_annualized`
      listObject[["trailing_five_year_annualized_return_split_and_dividend"]] <- self$`trailing_five_year_annualized_return_split_and_dividend`
      listObject[["trailing_five_year_annualized_return_split_only"]] <- self$`trailing_five_year_annualized_return_split_only`
      listObject[["trailing_five_year_volatility_annualized"]] <- self$`trailing_five_year_volatility_annualized`
      listObject[["trailing_ten_year_annualized_return_split_and_dividend"]] <- self$`trailing_ten_year_annualized_return_split_and_dividend`
      listObject[["trailing_ten_year_annualized_return_split_only"]] <- self$`trailing_ten_year_annualized_return_split_only`
      listObject[["inception_annualized_return_split_and_dividend"]] <- self$`inception_annualized_return_split_and_dividend`
      listObject[["inception_annualized_return_split_only"]] <- self$`inception_annualized_return_split_only`
      listObject[["calendar_year_5_return_split_and_dividend"]] <- self$`calendar_year_5_return_split_and_dividend`
      listObject[["calendar_year_5_return_split_only"]] <- self$`calendar_year_5_return_split_only`
      listObject[["calendar_year_4_return_split_and_dividend"]] <- self$`calendar_year_4_return_split_and_dividend`
      listObject[["calendar_year_4_return_split_only"]] <- self$`calendar_year_4_return_split_only`
      listObject[["calendar_year_3_return_split_and_dividend"]] <- self$`calendar_year_3_return_split_and_dividend`
      listObject[["calendar_year_3_return_split_only"]] <- self$`calendar_year_3_return_split_only`
      listObject[["calendar_year_2_return_split_and_dividend"]] <- self$`calendar_year_2_return_split_and_dividend`
      listObject[["calendar_year_2_return_split_only"]] <- self$`calendar_year_2_return_split_only`
      listObject[["calendar_year_1_return_split_and_dividend"]] <- self$`calendar_year_1_return_split_and_dividend`
      listObject[["calendar_year_1_return_split_only"]] <- self$`calendar_year_1_return_split_only`
      listObject[["calendar_year_to_date_return_split_and_dividend"]] <- self$`calendar_year_to_date_return_split_and_dividend`
      listObject[["calendar_year_to_date_return_split_only"]] <- self$`calendar_year_to_date_return_split_only`




      etf_list <- self$`etf`$getAsList()
      for (x in names(etf_list)) {
        listObject[[paste("etf_",x, sep = "")]] <- self$`etf`[[x]]
      }
        
      return(listObject)
    }
  )
)
