# Intrinio API
#
# Welcome to the Intrinio API! Through our Financial Data Marketplace, we offer a wide selection of financial data feed APIs sourced by our own proprietary processes as well as from many data vendors. For a complete API request / response reference please view the [Intrinio API documentation](https://intrinio.com/documentation/api_v2). If you need additional help in using the API, please visit the [Intrinio website](https://intrinio.com) and click on the chat icon in the lower right corner.
#
# OpenAPI spec version: 2.23.0
# 
# Generated by: https://github.com/swagger-api/swagger-codegen.git


#' TheaSourceDocumentTags Class
#'
#' @field key 
#' @field value 
#'
#' @importFrom R6 R6Class
#' @importFrom jsonlite fromJSON toJSON
#' @export
TheaSourceDocumentTags <- R6::R6Class(
  'TheaSourceDocumentTags',
  public = list(
    `key` = NA,
    `value` = NA,
    initialize = function(`key`, `value`){
      if (!missing(`key`)) {
        self$`key` <- `key`
      }
      if (!missing(`value`)) {
        self$`value` <- `value`
      }
    },
    toJSON = function() {
      TheaSourceDocumentTagsObject <- list()
      if (!is.null(self$`key`)) {
        # If the object is an empty list or a list of R6 Objects
        if (is.list(self$`key`) && ((length(self$`key`) == 0) || ((length(self$`key`) != 0 && R6::is.R6(self$`key`[[1]]))))) {
          TheaSourceDocumentTagsObject[['key']] <- lapply(self$`key`, function(x) x$toJSON())
        } else {
          TheaSourceDocumentTagsObject[['key']] <- jsonlite::toJSON(self$`key`, auto_unbox = TRUE)
        }
      }
      if (!is.null(self$`value`)) {
        # If the object is an empty list or a list of R6 Objects
        if (is.list(self$`value`) && ((length(self$`value`) == 0) || ((length(self$`value`) != 0 && R6::is.R6(self$`value`[[1]]))))) {
          TheaSourceDocumentTagsObject[['value']] <- lapply(self$`value`, function(x) x$toJSON())
        } else {
          TheaSourceDocumentTagsObject[['value']] <- jsonlite::toJSON(self$`value`, auto_unbox = TRUE)
        }
      }

      TheaSourceDocumentTagsObject
    },
    fromJSON = function(TheaSourceDocumentTagsJson) {
      TheaSourceDocumentTagsObject <- jsonlite::fromJSON(TheaSourceDocumentTagsJson)
      if (!is.null(TheaSourceDocumentTagsObject$`key`)) {
        self$`key` <- TheaSourceDocumentTagsObject$`key`
      }
      if (!is.null(TheaSourceDocumentTagsObject$`value`)) {
        self$`value` <- TheaSourceDocumentTagsObject$`value`
      }
    },
    toJSONString = function() {
      jsonlite::toJSON(self$toJSON(), auto_unbox = TRUE, pretty = TRUE)
    },
    fromJSONString = function(TheaSourceDocumentTagsJson) {
      TheaSourceDocumentTagsObject <- jsonlite::fromJSON(TheaSourceDocumentTagsJson, simplifyDataFrame = FALSE)
      self$setFromList(TheaSourceDocumentTagsObject)
    },
    setFromList = function(listObject) {
      if (!is.null(listObject$`key`)) {
        self$`key` <- listObject$`key`
      }
      else {
        self$`key` <- NA 
      }

      if (!is.null(listObject$`value`)) {
        self$`value` <- listObject$`value`
      }
      else {
        self$`value` <- NA 
      }

    },
    getAsList = function() {
      listObject = list()
      listObject[["key"]] <- self$`key`
      listObject[["value"]] <- self$`value`
      return(listObject)
    }
  )
)
